=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2011-11-28 14:15:02 +0000
+++ bzrlib/workingtree.py	2011-11-28 15:18:59 +0000
@@ -88,6 +88,10 @@
     )
 from bzrlib.trace import mutter, note
 from bzrlib.revision import CURRENT_REVISION
+from bzrlib.symbol_versioning import (
+    deprecated_passed,
+    DEPRECATED_PARAMETER,
+    )
 
 
 MERGE_MODIFIED_HEADER_1 = "BZR merge-modified list format 1"
@@ -167,6 +171,7 @@
         return views.DisabledViews(self)
 
     def __init__(self, basedir='.',
+                 branch=DEPRECATED_PARAMETER,
                  _internal=False,
                  _transport=None,
                  _format=None,
@@ -182,7 +187,10 @@
                 "WorkingTree.open() to obtain a WorkingTree.")
         basedir = safe_unicode(basedir)
         mutter("opening working tree %r", basedir)
-        self._branch = self.bzrdir.open_branch()
+        if deprecated_passed(branch):
+            self._branch = branch
+        else:
+            self._branch = self.bzrdir.open_branch()
         self.basedir = realpath(basedir)
         self._transport = _transport
         self._rules_searcher = None
@@ -1727,6 +1735,7 @@
     """
 
     def __init__(self, basedir='.',
+                 branch=DEPRECATED_PARAMETER,
                  _inventory=None,
                  _control_files=None,
                  _internal=False,
@@ -1737,7 +1746,7 @@
         :param branch: A branch to override probing for the branch.
         """
         super(InventoryWorkingTree, self).__init__(basedir=basedir,
-            _transport=_control_files._transport,
+            branch=branch, _transport=_control_files._transport,
             _internal=_internal, _format=_format, _bzrdir=_bzrdir)
 
         self._control_files = _control_files

=== modified file 'bzrlib/workingtree_3.py'
--- bzrlib/workingtree_3.py	2011-11-28 13:41:58 +0000
+++ bzrlib/workingtree_3.py	2011-11-28 15:18:59 +0000
@@ -207,6 +207,7 @@
         # inv = Inventory(root_id=gen_root_id())
         inv = self._initial_inventory()
         wt = self._tree_class(a_bzrdir.root_transport.local_abspath('.'),
+                         branch,
                          inv,
                          _internal=True,
                          _format=self,

